/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#pragma once

#if ENABLE(PAYMENT_REQUEST)

#include "JSDOMConvertDictionary.h"
#include "JSDOMWrapper.h"
#include "JSPaymentRequestUpdateEvent.h"
#include "PaymentMethodChangeEvent.h"

namespace WebCore {

class JSPaymentMethodChangeEvent : public JSPaymentRequestUpdateEvent {
public:
    using Base = JSPaymentRequestUpdateEvent;
    using DOMWrapped = PaymentMethodChangeEvent;
    static JSPaymentMethodChangeEvent* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<PaymentMethodChangeEvent>&& impl)
    {
        JSPaymentMethodChangeEvent* ptr = new (NotNull, JSC::allocateCell<JSPaymentMethodChangeEvent>(globalObject->vm().heap)) JSPaymentMethodChangeEvent(structure, *globalObject, WTFMove(impl));
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSDOMGlobalObject&);
    static JSC::JSObject* prototype(JSC::VM&, JSDOMGlobalObject&);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::JSType(JSEventType), StructureFlags), info());
    }

    static JSC::JSValue getConstructor(JSC::VM&, const JSC::JSGlobalObject*);
    static void visitChildren(JSCell*, JSC::SlotVisitor&);
    void visitAdditionalChildren(JSC::SlotVisitor&);

    static void visitOutputConstraints(JSCell*, JSC::SlotVisitor&);
    template<typename, JSC::SubspaceAccess> static JSC::CompleteSubspace* subspaceFor(JSC::VM& vm) { return outputConstraintSubspaceFor(vm); }
    static void analyzeHeap(JSCell*, JSC::HeapAnalyzer&);

    // Custom attributes
    JSC::JSValue methodDetails(JSC::JSGlobalObject&) const;
    PaymentMethodChangeEvent& wrapped() const
    {
        return static_cast<PaymentMethodChangeEvent&>(Base::wrapped());
    }
protected:
    JSPaymentMethodChangeEvent(JSC::Structure*, JSDOMGlobalObject&, Ref<PaymentMethodChangeEvent>&&);

    void finishCreation(JSC::VM&);
};

JSC::JSValue toJS(JSC::JSGlobalObject*, JSDOMGlobalObject*, PaymentMethodChangeEvent&);
inline JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, PaymentMethodChangeEvent* impl) { return impl ? toJS(lexicalGlobalObject, globalObject, *impl) : JSC::jsNull(); }
JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject*, Ref<PaymentMethodChangeEvent>&&);
inline JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, RefPtr<PaymentMethodChangeEvent>&& impl) { return impl ? toJSNewlyCreated(lexicalGlobalObject, globalObject, impl.releaseNonNull()) : JSC::jsNull(); }

template<> struct JSDOMWrapperConverterTraits<PaymentMethodChangeEvent> {
    using WrapperClass = JSPaymentMethodChangeEvent;
    using ToWrappedReturnType = PaymentMethodChangeEvent*;
};
#if ENABLE(PAYMENT_REQUEST)

template<> PaymentMethodChangeEvent::Init convertDictionary<PaymentMethodChangeEvent::Init>(JSC::JSGlobalObject&, JSC::JSValue);

#endif


} // namespace WebCore

#endif // ENABLE(PAYMENT_REQUEST)
