/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#pragma once

#if ENABLE(SPEECH_SYNTHESIS)

#include "JSDOMWrapper.h"
#include "JSEventTarget.h"
#include "SpeechSynthesisUtterance.h"

namespace WebCore {

class JSSpeechSynthesisUtterance : public JSEventTarget {
public:
    using Base = JSEventTarget;
    using DOMWrapped = SpeechSynthesisUtterance;
    static JSSpeechSynthesisUtterance* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<SpeechSynthesisUtterance>&& impl)
    {
        JSSpeechSynthesisUtterance* ptr = new (NotNull, JSC::allocateCell<JSSpeechSynthesisUtterance>(globalObject->vm().heap)) JSSpeechSynthesisUtterance(structure, *globalObject, WTFMove(impl));
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSDOMGlobalObject&);
    static JSC::JSObject* prototype(JSC::VM&, JSDOMGlobalObject&);
    static SpeechSynthesisUtterance* toWrapped(JSC::VM&, JSC::JSValue);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

    static JSC::JSValue getConstructor(JSC::VM&, const JSC::JSGlobalObject*);
    static void analyzeHeap(JSCell*, JSC::HeapAnalyzer&);
    SpeechSynthesisUtterance& wrapped() const
    {
        return static_cast<SpeechSynthesisUtterance&>(Base::wrapped());
    }
protected:
    JSSpeechSynthesisUtterance(JSC::Structure*, JSDOMGlobalObject&, Ref<SpeechSynthesisUtterance>&&);

    void finishCreation(JSC::VM&);
};

JSC::JSValue toJS(JSC::JSGlobalObject*, JSDOMGlobalObject*, SpeechSynthesisUtterance&);
inline JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, SpeechSynthesisUtterance* impl) { return impl ? toJS(lexicalGlobalObject, globalObject, *impl) : JSC::jsNull(); }
JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject*, Ref<SpeechSynthesisUtterance>&&);
inline JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, RefPtr<SpeechSynthesisUtterance>&& impl) { return impl ? toJSNewlyCreated(lexicalGlobalObject, globalObject, impl.releaseNonNull()) : JSC::jsNull(); }

template<> struct JSDOMWrapperConverterTraits<SpeechSynthesisUtterance> {
    using WrapperClass = JSSpeechSynthesisUtterance;
    using ToWrappedReturnType = SpeechSynthesisUtterance*;
};

} // namespace WebCore

#endif // ENABLE(SPEECH_SYNTHESIS)
