/*
 * Copyright (C) 2010-2018 Apple Inc. All rights reserved.
 * Copyright (C) 2017 Sony Interactive Entertainment Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY APPLE INC. AND ITS CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL APPLE INC. OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */
 
//+TELESCOPE_LIB_CHANGES
// 4/8/2020
// WTF library for PS4

#include "config.h"
#include <wtf/WorkQueue.h>

#include <wtf/MathExtras.h>
#include <wtf/Threading.h>

namespace WTF {

unsigned int WorkQueue::workThreadCallback(void* context)
{
    assert(0);
    return 0;
}

void WorkQueue::performWorkOnRegisteredWorkThread()
{
    assert(0);
}

void WorkQueue::platformInitialize(const char* name, Type, QOS)
{
    assert(0);
}

bool WorkQueue::tryRegisterAsWorkThread()
{
    assert(0);
    return true;
}

void WorkQueue::unregisterAsWorkThread()
{
    assert(0);
}

void WorkQueue::platformInvalidate()
{
    assert(0);
}

void WorkQueue::dispatch(Function<void()>&& function)
{
    assert(0);
}

struct TimerContext : public ThreadSafeRefCounted<TimerContext> {
    static Ref<TimerContext> create() { return adoptRef(*new TimerContext); }

    Lock timerLock;
    WorkQueue* queue { nullptr };
    HANDLE timer { nullptr };
    Function<void()> function;

private:
    TimerContext() = default;
};

void WorkQueue::timerCallback(void* context, bool timerOrWaitFired)
{
    assert(0);
}

void WorkQueue::dispatchAfter(Seconds duration, Function<void()>&& function)
{
    assert(0);
}

} // namespace WTF

//-TELESCOPE_LIB_CHANGES
